package ac.essex.ooechs.facedetection.boosting;

import ac.essex.ooechs.adaboost.AdaBoostLearner;
import ac.essex.ooechs.adaboost.AdaBoostSample;
import ac.essex.ooechs.imaging.commons.fast.IntegralImage;
import ac.essex.ooechs.facedetection.util.DataSet;
import ac.essex.ooechs.facedetection.util.IntegralTrainingImage;
import ac.essex.gp.individuals.Individual;
import ac.essex.gp.problems.DataStack;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 26-Jun-2008
 * @version 1.0
 */
public class GPLearner extends AdaBoostLearner {

    protected Individual ind;

    public GPLearner(Individual ind) {
        this.ind = ind;
    }

    public int classify(AdaBoostSample adaBoostSample, Object object) {
        DataStack dataStack = new DataStack();

            dataStack.setIntegralImage((IntegralImage) (adaBoostSample.getData()));

            double raw = ind.execute(dataStack);

            int result;

            if (ind.getPCM() != null) {
                result = ind.getPCM().getClassFromOutput(raw);
            } else {
                result = raw > 0 ? DataSet.TRUE : DataSet.FALSE;
            }

        if (result < 0) result = 0;
/*
        if (result == adaBoostSample.getLabel()) {
            System.out.println("Result: " + result);
        } else {
            System.out.println(result + "!=" + adaBoostSample.getLabel());
        }*/

        return result;

    }
    
}
