package ac.essex.ooechs.facedetection.evolved.gp.nodes;

import ac.essex.gp.tree.Node;
import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.problems.DataStack;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 13-Jun-2008
 * @version 1.0
 */
public class EvolvedTwoRectangleFeature extends Node {

   public EvolvedTwoRectangleFeature() {
        super(2);
    }

    /**
     * Tells what return type each of the node's children should have
     */
    public int getChildType(int index) {
        return NodeConstraints.FEATURE;
    }

    public int getReturnType() {
        return NodeConstraints.NUMBER;
    }

    public double execute(DataStack data) {
        data.value = child[0].execute(data) - child[1].execute(data);
        return debugger.record(data.value);
    }

    public String toJava() {
        return child[0].getName() + " - " + child[1].getName();
    }

}

