package ac.essex.ooechs.facedetection.util.evaluation;

import ac.essex.gp.multiclass.PCM;
import ac.essex.gp.multiclass.BetterDRS;
import ac.essex.ooechs.imaging.commons.fast.HaarlikeFeatures;
import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.imaging.commons.PixelLoader;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 03-Jul-2008
 * @version 1.0
 */
public class EyeDetector extends ObjectDetector {

PCM pcm0 = new BetterDRS(0.0,2.0091954022988507,new int[]{0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,0,0,-1,-1,1,-1,-1,1,0,-1,-1,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0});
    
public double calculate(int x, int y, int windowWidth, int windowHeight, PixelLoader img) {

    HaarlikeFeatures image = img.getIntegralImage().getHaarlikeFeatures();
    HaarlikeFeatures varianceimage = img.getIntegralImage().getHaarlikeFeaturesVariance();

    double node2 = image.getThreeRectangleFeature(x + 0,  y + 1, 5, 1, HaarRegions.HORIZONTALLY_ADJACENT);
    double node7 = varianceimage.getThreeRectangleFeature(x + 0, y + 17, 1, 1, HaarRegions.VERTICALLY_ADJACENT);
    double node1 = node7 != 0 ? node2 / node7 : 0;
    double node12 = image.getThreeRectangleFeature(x + 0, y + 0, 1, 1, HaarRegions.HORIZONTALLY_ADJACENT);
    return pcm0.getClassFromOutput(Math.min(node1, node12));
    
}


}
