package ac.essex.ooechs.facedetection.util.evaluation;

import ac.essex.gp.multiclass.PCM;
import ac.essex.gp.multiclass.BetterDRS;
import ac.essex.gp.individuals.Individual;
import ac.essex.gp.problems.DataStack;
import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.imaging.commons.fast.HaarlikeFeatures;
import ac.essex.ooechs.facedetection.singlestage.nodes.FeatureUtils;
import ac.essex.ooechs.facedetection.util.DataSet;

import java.io.File;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 07-Jul-2008
 * @version 1.0
 */
public class MouthDetector2 extends ObjectDetector {

    Individual ind;

    public static void main(String[] args) throws Exception {
        MouthDetector d = new MouthDetector();
        d.test(new File("/home/ooechs/Data/me/smile/mouth/smiley/"));
        d.test(new File("/home/ooechs/Data/me/smile/notmouth/"));
    }

    public MouthDetector2() throws Exception {
        ind = Individual.load(new File("/home/ooechs/Desktop/saved.solution"));
    }

    public double calculate(int x, int y, int windowWidth, int windowHeight, PixelLoader img) {
        DataStack d = new DataStack();
        d.setIntegralImage(img.getIntegralImage());
            double raw = ind.execute(d);

            int result;

            if (ind.getPCM() != null) {
                result = ind.getPCM().getClassFromOutput(raw);
            } else {
                result = raw > 0 ? DataSet.TRUE : DataSet.FALSE;
            }
        return result;
    }

}
