package ac.essex.ooechs.facedetection.util.evaluation;

import ac.essex.ooechs.imaging.commons.ColourChannels;
import ac.essex.ooechs.imaging.commons.PixelLoader;
import ac.essex.ooechs.imaging.commons.segmentation.Segmenter;
import ac.essex.gp.multiclass.BetterDRS;
import ac.essex.gp.multiclass.PCM;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 03-Jul-2008
 * @version 1.0
 */
public class SkinSegmenter extends Segmenter {
/*
    PCM pcm0 = new BetterDRS(-25573.83316040039,18847.9885690948,new int[]{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2});;
    public int segment(PixelLoader image, int x, int y) {
        double node2 = image.get3x3Stats(x, y, ColourChannels.RED).getMean() - image.get3x3Stats(x, y, ColourChannels.GREEN).getMean();
        double node5 = image.get3x3Stats(x, y, ColourChannels.BLUE).getMean() + image.getBlue(x, y);
        double node1 = node2 * node5;
        return pcm0.getClassFromOutput(node1 + image.getPerimeter1().getStatistics(image, x, y).getMean()) - 1;
    }*/

PCM pcm0 = new BetterDRS(0.008317784382298079,0.39387601613998413,new int[]{1,-1,1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,1,1,1,1});;
//PCM pcm0 = new BetterDRS(-11.098610497631121,52344.60140991211,new int[]{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,-1,1,1});;
//    PCM pcm0 = new BetterDRS(-81.60990746793786,239.3333282470703,new int[]{1,1,2,-1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2});;
public int segment(PixelLoader image, int x, int y) {
  /*  double node2 = image.getLightness(x, y) - image.getGreen(x, y);
    double node1 = node2 > 0? image.getLightness(x, y) : -0.04147195805498827;
    return pcm0.getClassFromOutput(node1 * image.getPerimeter2().getStatistics(image, x, y).getMean()) - 1;
*/
  double node7 = image.getSatMean() + image.getSaturation(x, y);
    double node4 = image.getSaturation(x, y) > 0? image.get3x3Variance(x, y) : node7;
    double node2 = image.getPerimeter2().getStatistics(image, x, y).getMin() - node4;
    double node10 = image.getHLine2().getEdgeCount(image, x, y) > 0? 0 : image.getLightness(x, y);
    double node1 = node2 > 0? node10 : 0.0;
    double node16 = 0.0705138437884274 * 0.11795959396647128;
    return pcm0.getClassFromOutput(node1 > 0? image.get3x3Stats(x, y, ColourChannels.GREEN).getMean() : node16)-1;  
}

}
